src/Entity/Module.php
<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Validator\Constraints as Assert;
/**
 * @ORM\Entity(repositoryClass="App\Repository\ModuleRepository")
 * @UniqueEntity(fields={"libelle_module_fr"} ,message="Module déja existant!!")
 * @UniqueEntity(fields={"libelle_module_ar"} ,message="Module déja existant!!")
 */
class Module
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank(message="Le libéllé français est obligatoire")
     */
    private $libelle_module_fr;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank(message="Le libéllé arabe est obligatoire")
     */
    private $libelle_module_ar;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Matiere", mappedBy="module")
     */
    private $matieres;
    private $libelle_module;

    public function __construct()
    {
        $this->matieres = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getLibelleModuleFr(): ?string
    {
        return $this->libelle_module_fr;
    }

    public function setLibelleModuleFr(string $libelle_module_fr): self
    {
        $this->libelle_module_fr = $libelle_module_fr;

        return $this;
    }

    public function getLibelleModuleAr(): ?string
    {
        return $this->libelle_module_ar;
    }

    public function setLibelleModuleAr(string $libelle_module_ar): self
    {
        $this->libelle_module_ar = $libelle_module_ar;

        return $this;
    }

    /**
     * @return Collection|Matiere[]
     */
    public function getMatieres(): Collection
    {
        return $this->matieres;
    }

    public function addMatiere(Matiere $matiere): self
    {
        if (!$this->matieres->contains($matiere)) {
            $this->matieres[] = $matiere;
            $matiere->setModule($this);
        }

        return $this;
    }

    public function removeMatiere(Matiere $matiere): self
    {
        if ($this->matieres->contains($matiere)) {
            $this->matieres->removeElement($matiere);
            // set the owning side to null (unless already changed)
            if ($matiere->getModule() === $this) {
                $matiere->setModule(null);
            }
        }

        return $this;
    }
    public function __toString(){
        // to show the name of the Category in the select
        return $this->libelle_module_ar;
        // to show the id of the Category in the select
        // return $this->id;
    }
    public function getLibelleModule(): ?string
    {
        return $this->libelle_module_fr."  [ ".$this->libelle_module_ar."]";
    }
}

src/Form/ModuleType.php
<?php

namespace App\Form;

use App\Entity\Module;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class ModuleType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('libelle_module_fr',TextType::class, array(
                'required' => false,
                'label' => 'Nom du Module en Français : ',
                'attr' => array(
                    'class' => 'form-control')))
            ->add('libelle_module_ar',TextType::class, array(
                'required' => false,
                'label' => 'Nom du Module en Arabe : ',
                'attr' => array(
                    'class' => 'form-control')))
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Module::class,
        ]);
    }
}

src/Controller/ModuleController.php
<?php

namespace App\Controller;

use App\Entity\Module;
use App\Form\ModuleType;
use App\Repository\ModuleRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Security;
use Symfony\Component\HttpFoundation\Session\SessionInterface;

/**
 * @Route("/module")
 * @Security("is_granted('ROLE_ADMIN')")
 */
class ModuleController extends AbstractController
{
    protected $session;

    public function __construct(SessionInterface $session)
    {
        $this->session = $session;
    }
    /**
     * @Route("/", name="module_index", methods={"GET","POST"})
     */
    public function index(ModuleRepository $moduleRepository, Request $request): Response
    {
        $module = new Module();
        $form = $this->createForm(ModuleType::class, $module);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($module);
            $entityManager->flush();
            $this->addFlash("info", "Module Ajouter Avec Succés");
            return $this->redirectToRoute('module_index');
        }
        return $this->render('module/index.html.twig', [
            'modules' => $moduleRepository->findAll(), 'module' => $module,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/new", name="module_new", methods={"GET","POST"})
     */
    public function new(Request $request): Response
    {
        $module = new Module();
        $form = $this->createForm(ModuleType::class, $module);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($module);
            $entityManager->flush();
            $this->addFlash("info", "Module Ajouter Avec Succés");
            return new Response('ok');
        }

        return $this->render('module/_form.html.twig', [
            'module' => $module,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="module_show", methods={"GET"})
     */
    public function show(Module $module): Response
    {
        return $this->render('module/show.html.twig', [
            'module' => $module,
        ]);
    }

    /**
     * @Route("/{id}/edit", name="module_edit", methods={"GET","POST"})
     */
    public function edit(Request $request, Module $module): Response
    {
        $form = $this->createForm(ModuleType::class, $module);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->getDoctrine()->getManager()->flush();
            $this->addFlash("info", "Module Modifier Avec Succés");

            return new Response('ok');
        }

        return $this->render('module/_form_edit.html.twig', [
            'module' => $module,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="module_delete", methods={"DELETE"})
     */
    public function delete(Request $request, Module $module): Response
    {
        if ($this->isCsrfTokenValid('delete' . $module->getId(), $request->request->get('_token'))) {
            if($module->getMatieres()->count()>0){
                $this->session->getFlashBag()->add('danger', 'Ce module ne peut pas etre supprimer');
            }
            else{
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($module);
            $entityManager->flush();
                $this->addFlash("info", "Module supprimer Avec Succés");
        }
        }
        return $this->redirectToRoute('module_index');
    }
}

templates/module/_delete_form.html.twig
<form method="post" id="form_delete_module_{{ module.id }}" action="{{ path('module_delete', {'id': module.id}) }}" >
    <input type="hidden" name="_method" value="DELETE">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ module.id) }}">
    <button type="button" class="btn btn-danger btn_del_module" id_module="{{ module.id }}" name_module="{{ module.libelleModuleFr }}" ><span class="glyphicon glyphicon-trash" title="Supprimer module" ></span></button>
</form>

templates/module/_form.html.twig
{% form_theme form 'bootstrap_3_layout.html.twig' %}
<div class="w3-container">
    <div class="card-columns">
        <div class="card ">
            <div class="card-body">
                {{ form_start(form,{'attr':{'id':'form_add_module','action':path('module_new'),'novalidate':'novalidate'} }) }}
                {{ form_widget(form) }}
                <button class="btn btn-primary save_module" type="button" >{{ button_label|default('Enregistrer') }}</button>
                {{ form_end(form) }}

            </div>
        </div>
    </div>
</div>

templates/module/_form_edit.html.twig
{% form_theme form 'bootstrap_3_layout.html.twig' %}
<div class="w3-container">
    <div class="card-columns">
        <div class="card ">
            <div class="card-body">
                {{ form_start(form,{'attr':{'id':'form_add_module','action':path('module_edit', {'id': module.id}),'novalidate':'novalidate'} }) }}
                {{ form_widget(form) }}
                <button class="btn btn-primary edit_module" type="button" >{{ button_label|default('Modifier') }}</button>
                {{ form_end(form) }}

            </div>
        </div>
    </div>
</div>

templates/module/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Liste Module {% endblock %}

{% block body %}

    {% for message in app.flashes('info') %}
        <div class="alert alert-success">{{ message }}</div>
    {% endfor %}

    <td>
        <a>
            <button class="btn btn-success btn_new_module" url="{{ path('module_new') }}"><span
                        class="glyphicon glyphicon-plus" title="Ajouter nouveau module"> Ajouter</span></button>
        </a>
    </td>
    <div class="box">
        <div class="box-header">
            <h3 class="box-title">Liste des Modules </h3>
        </div>
        <!-- /.box-header -->
        <div class="box-body">
            <table id="" class="table table-bordered table-striped">
                <thead>
                <tr>

                    <th>Nom du Module en Français :</th>
                    <th>Nom du Module en Arabe :</th>
                    <th>Action</th>
                </tr>
                </thead>
                <tbody>
                {% for module in modules %}
                    <tr>

                        <td>{{ module.libelleModuleFr }}</td>
                        <td>{{ module.libelleModuleAr }}</td>
                        <td>
                            <ul class="list_act_ens">
                                <li>
                                    <a>
                                        <button class="btn btn-primary btn_info_module"
                                                url="{{ path('module_show', {'id': module.id}) }}"><span
                                                    class="glyphicon glyphicon-info-sign" title="Détail"></span>
                                        </button>
                                    </a>
                                </li>
                                <li>
                                    <a>
                                        <button class="btn btn-success btn_edit_module"
                                                url="{{ path('module_edit', {'id':module.id}) }}"><span
                                                    class="glyphicon glyphicon-pencil" title="Modifier module"></span>
                                        </button>
                                    </a>
                                </li>
                                <li>
                                    {{ include('module/_delete_form.html.twig') }}</li>
                            </ul>
                        </td>

                    </tr>

                {% else %}
                    <tr>
                        <td colspan="4">Pas D'enregistrement</td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>

            {#fenetre modale #}

            <div class="modal fade" id="modalModule" tabindex="-1" role="dialog" aria-labelledby="myModalLabel"
                 aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header text-center">
                            <h4 class="modal-title w-100 font-weight-bold titre_modal_module">Ajouter Un Module</h4>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            <div class="text-center">
                                <img src="{{ asset('images/loading.svg') }}" class="load_modal_body">
                            </div>
                            <div class="content_modal_body">
                            </div>

                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-danger pull-right" data-dismiss="modal">Fermer</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}
{% block mesJavascripts %}

    <script>
        $('body').on('click', '.btn_new_module', function (event) {
            $('#modalModule').modal('show');
            $('.content_modal_body').html('');
            $('.load_modal_body').show();
            $('.titre_modal_module').html('Ajouter nouvelle module');
            $('.modal-footer').html('<button type="button" class="btn btn-danger pull-right" data-dismiss="modal">Fermer</button>');
            var url = $(this).attr('url');
            $.ajax({
                url: url,
                method: 'POST',
                success: function (result) {
                    $('.load_modal_body').hide();
                    $('.content_modal_body').html(result);
                }
            });
        });
        $('body').on('click', '.btn_edit_module', function (event) {
            $('#modalModule').modal('show');
            $('.content_modal_body').html('');
            $('.modal-footer').html('<button type="button" class="btn btn-danger pull-right" data-dismiss="modal">Fermer</button>');
            $('.load_modal_body').show();
            $('.titre_modal_module').html('Modifier module');
            var url = $(this).attr('url');
            $.ajax({
                url: url,
                method: 'POST',
                success: function (result) {
                    $('.load_modal_body').hide();
                    $('.content_modal_body').html(result);
                }
            });
        });
        $('body').on('click', '.btn_info_module', function (event) {
            $('#modalModule').modal('show');
            $('.content_modal_body').html('');
            $('.load_modal_body').show();
            $('.modal-footer').html('<button type="button" class="btn btn-danger pull-right" data-dismiss="modal">Fermer</button>');
            $('.titre_modal_module').html('Info module');
            var url = $(this).attr('url');
            $.ajax({
                url: url,
                method: 'GET',
                success: function (result) {
                    $('.load_modal_body').hide();
                    $('.content_modal_body').html(result);
                }
            });
        });
        $('body').on('click', '.btn_del_module', function (event) {
            var name_module = $(this).attr('name_module');
            var id_module = $(this).attr('id_module');
            $('#modalModule').modal('show');
            $('.content_modal_body').html('');

            $('.titre_modal_module').html('Supprimer module');

            $('.content_modal_body').html('Voulez-vous vraiment supprimer la module: <b>' + name_module + '</b>');
            $('.modal-footer').html('<button type="button" class="btn btn-warning pull-right" data-dismiss="modal">Annuler</button><button type="button" class="btn btn-danger pull-right confirm_delete_module" onclick="confirmer_delete_module(' + id_module + ')" data-dismiss="modal">Confirmer</button>');
        });

        function confirmer_delete_module(id_module) {
            $('#form_delete_module_' + id_module).submit();
        }

        $('body').on('click', '.save_module', function (event) {

            var form = $('#form_add_module');
            var formData = new FormData(document.getElementById("form_add_module"));

            $.ajax({
                type: 'POST',
                cache: false,
                data: formData,
                url: form.attr('action'),
                processData: false,
                contentType: false,

                beforeSend: function (XMLHttpRequest) {
                    $('#form_add_module').attr('disabled', true);
                },

                success: function (msg) {
                    if (msg == 'ok') {
                        $('#modalModule').modal('hide');
                        location.reload();
                    } else {
                        $('.content_modal_body').html(msg);
                        //alert('erreur');
                    }
                }
            });

        });
        $('body').on('click', '.edit_module', function (event) {

            var form = $('#form_add_module');
            var formData = new FormData(document.getElementById("form_add_module"));

            $.ajax({
                type: 'POST',
                cache: false,
                data: formData,
                url: form.attr('action'),
                processData: false,
                contentType: false,

                beforeSend: function (XMLHttpRequest) {
                    $('#form_add_module').attr('disabled', true);

                },

                success: function (msg) {
                    if (msg == 'ok') {
                        $('#modalModule').modal('hide');
                        location.reload();
                    } else {
                        $('.content_modal_body').html(msg);
                        //alert('erreur');
                    }
                }
            });

        });

        function supprimer_module(name_module) {
            $('#modalModule').modal('show');
            $('.content_modal_body').html('');

            $('.titre_modal_module').html('Supprimer module');

            $('.content_modal_body').html('Voulez-vous vraiment supprimer la module: ' + name_module);
            return false;
        }
    </script>

{% endblock %}

templates/module/show.html.twig
<table class="table">
    <tbody>
    <tr>
        <th>Libelle module français</th>
        <td>{{ module.libelleModuleFr }}</td>
    </tr>
    <tr>
        <th>Libelle module arabe</th>
        <td>{{ module.libelleModuleAr }}</td>
    </tr>
    </tbody>
</table>